#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# This is a simple whois daemon intended to
# provide a basic whois for GNet. 
#

import pywhois
from optparse import OptionParser

if __name__ == "__main__":

    parser = OptionParser()
    parser.add_option("-v", "--verbose", action="store_true",
                      default = False, help = "Print syslog to screen")
    parser.add_option("-c", "--config", dest="config_file",
                      default="pywhoisd.conf",
                      help = "Set config file", metavar="CONFIG_FILE")
    parser.add_option("-p", "--port", dest="port",
                      help = "The listening port of the daemon", default = "43")
    parser.add_option("-l", "--listen", help="The listening address of the daemon",
                      default = "0.0.0.0", dest="host")
    
    (options, args) = parser.parse_args()

    # Load configuration and create logger
    # istance
    config = pywhois.Config(options.config_file)
    logger = pywhois.Logger(options.verbose)

    # Prepare the real server, listening to the whole world
    host, port = options.host, int(options.port)
    server = pywhois.WhoisServer((host, port), logger, config)
    try:
        server.serve_forever()
    except KeyboardInterrupt:
        logger.Log ("pywhoisd daemon exiting now")

        
        
